const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class EarningsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const earnings = await db.earnings.create(
      {
        id: data.id || undefined,

        component: data.component || null,
        units: data.units || null,
        rate: data.rate || null,
        amount: data.amount || null,
        currency: data.currency || null,
        taxable: data.taxable || false,

        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await earnings.setPayroll_run(data.payroll_run || null, {
      transaction,
    });

    await earnings.setEmployee(data.employee || null, {
      transaction,
    });

    await earnings.setOrganizations(data.organizations || null, {
      transaction,
    });

    return earnings;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const earningsData = data.map((item, index) => ({
      id: item.id || undefined,

      component: item.component || null,
      units: item.units || null,
      rate: item.rate || null,
      amount: item.amount || null,
      currency: item.currency || null,
      taxable: item.taxable || false,

      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const earnings = await db.earnings.bulkCreate(earningsData, {
      transaction,
    });

    // For each item created, replace relation files

    return earnings;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const earnings = await db.earnings.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.component !== undefined) updatePayload.component = data.component;

    if (data.units !== undefined) updatePayload.units = data.units;

    if (data.rate !== undefined) updatePayload.rate = data.rate;

    if (data.amount !== undefined) updatePayload.amount = data.amount;

    if (data.currency !== undefined) updatePayload.currency = data.currency;

    if (data.taxable !== undefined) updatePayload.taxable = data.taxable;

    updatePayload.updatedById = currentUser.id;

    await earnings.update(updatePayload, { transaction });

    if (data.payroll_run !== undefined) {
      await earnings.setPayroll_run(
        data.payroll_run,

        { transaction },
      );
    }

    if (data.employee !== undefined) {
      await earnings.setEmployee(
        data.employee,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await earnings.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return earnings;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const earnings = await db.earnings.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of earnings) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of earnings) {
        await record.destroy({ transaction });
      }
    });

    return earnings;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const earnings = await db.earnings.findByPk(id, options);

    await earnings.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await earnings.destroy({
      transaction,
    });

    return earnings;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const earnings = await db.earnings.findOne({ where }, { transaction });

    if (!earnings) {
      return earnings;
    }

    const output = earnings.get({ plain: true });

    output.payroll_run = await earnings.getPayroll_run({
      transaction,
    });

    output.employee = await earnings.getEmployee({
      transaction,
    });

    output.organizations = await earnings.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.payroll_runs,
        as: 'payroll_run',

        where: filter.payroll_run
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.payroll_run
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  country: {
                    [Op.or]: filter.payroll_run
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.employees,
        as: 'employee',

        where: filter.employee
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.employee
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.employee
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.component) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('earnings', 'component', filter.component),
        };
      }

      if (filter.currency) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('earnings', 'currency', filter.currency),
        };
      }

      if (filter.unitsRange) {
        const [start, end] = filter.unitsRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            units: {
              ...where.units,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            units: {
              ...where.units,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.rateRange) {
        const [start, end] = filter.rateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            rate: {
              ...where.rate,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            rate: {
              ...where.rate,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.amountRange) {
        const [start, end] = filter.amountRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.taxable) {
        where = {
          ...where,
          taxable: filter.taxable,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.earnings.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('earnings', 'component', query),
        ],
      };
    }

    const records = await db.earnings.findAll({
      attributes: ['id', 'component'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['component', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.component,
    }));
  }
};
